(function($) {

	/**
	 * インジケータ表示範囲を管理するコントローラ
	 *
	 * @class indicatorController
	 */
	var indicatorController = {

		__name: 'indicatorPromiseController',

		/**
		 * インジケータ表示ボタン押下イベント
		 *
		 * @memberOf indicatorController
		 */
		'#indicator click': function(){

			this._dump('クリックイベントハンドラ 開始');

			// 4秒掛かる処理
			var func1 = this.own(function() {
				var df1 = this.deferred();
				setTimeout(this.own(function() {
					this._dump('処理1 end');
					df1.resolve();
				}), 4000);
				return df1.promise();
			});

			// 6秒掛かる処理
			var func2 = this.own(function() {
				var df2 = this.deferred();
				setTimeout(this.own(function() {
					this._dump('処理2 end');
					df2.resolve();
				}), 6000);
				return df2.promise();
			});

			// func1とfunc2が終わるのを待つので、6秒待つことになる。
			var indicator = this.indicator({
				target:'#indicator-target',
				promises: [func1(), func2()]
			}).show().message('処理中...');
		},

		_dump : function(message){
			this.$find('#dump').append('<li>' + message + '</li>');
		}
	};

	$(function(){
		h5.core.controller('body', indicatorController);
	});

})(jQuery);